/*
 *  Copyright (c) 1992, 1993 John E. Davis  (davis@amy.tch.harvard.edu)
 *  All Rights Reserved.
 */


/* These routines are fast memcpy, memset routines.  When available, I
   use system rouines.  For msdos, I use inline assembly. */
      
#include "mem.h"

#ifndef HAS_MEMSET
void jed_memset(char *p, char space, int n)
{
#ifndef msdos
   register char *pmax;

   pmax = p + (n - 4);
   n = n % 4;
   while(p <= pmax) 
     {
	*p++ = space; *p++ = space; *p++ = space; *p++ = space; 
     }
   while (n--) *p++ = space;
#else
   asm mov al, space
   asm mov dx, di
   asm les di, p
   asm mov cx, n
   asm cld
   asm rep stosb
   asm mov di, dx
#endif
}
#endif

#ifndef HAS_MEMCPY
char *jed_memcpy(char *s1, char *s2, int n)
{
#ifdef msdos
   asm mov ax, ds
   asm mov bx, si
   asm mov dx, di
   asm lds si, s2
   asm les di, s1
   asm mov cx, n
   asm rep movsb
   asm mov ds, ax
   asm mov si, bx
   asm mov di, dx
   return(s1);
   
#else
   register char *smax, s = s1;
   int n2;
   
   n2 = n % 4;
   smax = s + (n - 4);
   while(s <= smax) 
     {
	*s++ = *s2++; *s++ = *s2++; *s++ = *s2++; *s++ = *s2++;
     }
   while (n2--) *s++ = *s2++;
   return(s1); 
#endif
}
#endif

#ifndef HAS_MEMCMP   
int jed_memcmp(char *s1, char *s2, int n)
{
   int cmp;
   while(n--)
     {
	cmp = (unsigned char) *s1++ - (unsigned char) *s2++;
	if (cmp) return(cmp);
     }
   return(0);
}
#endif
